﻿-- Permission is granted to do whatever one wants with the code, and even
-- replace the contents of the original SVN module. I would be pleased if someone
-- started committing all sorts of crazy stuff.

local _G = getfenv(0)

local dataChangedTime
local menuUpdatedTime = -1 -- Force an update the first time the menu is opened

local L = AceLibrary("AceLocale-2.2"):new("BossWhisperer")

L:RegisterTranslations("enUS", function() return {
	["Bosswhisperer"] = true,
	["dndMessage"] = "I'm busy fighting %s (currently at %d%%). You'll be notified when combat ends.",
	["dndEndMessage"] = "Combat ended after %d minutes.",
	["Player Limit"] = true,
	["Maximum number of players to store messages for."] = true,
	["Suppress Outbound"] = true,
	["Suppress automated outbound whispers"] = true,
	["Suppress Inbound"] = true,
	["Suppress incoming whispers during an bossfight"] = true,
	["Suppress group members"] = true,
	["Suppress group/raid whispers during combat"] = true,
	["No whispers received"] = true,
	["Message Limit"] = true,
	["Maximum number of messages to store per player."] = true,
	["PlayerDesc"] = "Whispers sent/received from %s",
	["Reset before Combat"] = true,
	["Reset all previous incoming whispers when you start another bossfight."] = true,
	["Purge"] = "Purge whispers",
	["PurgeDesc"] = "Reset all current whispers being saved"
} end)

L:RegisterTranslations("zhCN", function() return {
	["Bosswhisperer"] = "战斗勿扰",
	["dndMessage"] = "非常抱歉,正在与 %s 战斗中(当前进度: %d%%). 当战斗结束后将会通知您.",
	["dndEndMessage"] = "通知: 战斗将于 %d 分钟后结束!",
	["Player Limit"] = "玩家数目上限",
	["Maximum number of players to store messages for."] = "保存最大玩家上限列表",
	["Suppress Outbound"] = "禁止信息输出",
	["Suppress automated outbound whispers"] = "禁止自动密语回复功能",
	["Suppress Inbound"] = "禁止信息接受",
	["Suppress incoming whispers during an bossfight"] = "战斗时禁止接受密语",
	["Suppress group members"] = "禁止接受队友信息",
	["Suppress group/raid whispers during combat"] = "战斗中禁止接受校对/团队的密语信息",
	["No whispers received"] = "未受到任何密语",
	["Message Limit"] = "信息数目上限",
	["Maximum number of messages to store per player."] = "设置每个玩家最大的信息数目上限",
	["PlayerDesc"] = "来自 %s 的密语",
	["Reset before Combat"] = "战斗前重置",
	["Reset all previous incoming whispers when you start another bossfight."] = "在下次BOSS战时重置所有接受的信息",
	["Purge"] = "清除密语信息",
	["PurgeDesc"] = "清除所有已被保存的密语信息Reset all current whispers being saved"
} end)

L:RegisterTranslations("zhTW", function() return {
	["Bosswhisperer"] = "戰鬥勿擾",
	["dndMessage"] = "抱歉，正與 %s 戰鬥中 (目前進度: %d%%) 當戰鬥結束將會另行通知！",
	["dndEndMessage"] = "報告：戰鬥於 %d分鐘 結束！",
	-- these need translation!
	["Player Limit"] = "儲存玩家數目上限",
	["Maximum number of players to store messages for."] = "儲存玩家數目上限",
	["Suppress Outbound"] = "暫停訊息輸出",
	["Suppress automated outbound whispers"] = "暫停自動回覆",
	["Suppress Inbound"] = "暫停訊息接收",
	["Suppress incoming whispers during an bossfight"] = "戰鬥中暫停接收密語",
	-- these need translation!
	["Suppress group members"] = "暫停接受隊友密語",
	["Suppress group/raid whispers during combat"] = "戰鬥中暫停接收小隊/團隊密語",
	-- /these need translation!
	["No whispers received"] = "未曾收到密語",
	["Message Limit"] = "訊息上限",
	["Maximum number of messages to store per player."] = "儲存訊息數目上限",
	["PlayerDesc"] = "來自 %s 的密語",
	["Reset before Combat"] = "戰鬥前重置",
	["Reset all previous incoming whispers when you start another bossfight."] = "下次戰鬥前將之前接收訊息重置",
	["Purge"] = "清除訊息",
	["PurgeDesc"] = "清除目前已存訊息"
} end)

L:RegisterTranslations("deDE", function() return {
	["Bosswhisperer"] = "BossNachrichten",
	["dndMessage"] = "Ich bin im Kampf mit %s (noch %d%% Leben). Du wirst nach Kampfende benachrichtigt werden.",
	["dndEndMessage"] = "Kampf beendet nach %d Minuten.",
	["Player Limit"] = "Spieler H\195\182chstanzahl",
	["Maximum number of players to store messages for."] = "H\195\182chstanzahl der Spieler f\195\188r die Nachrichten gespeichert werden",
	["Suppress Outbound"] = "Rausgehende Unterdr\195\188cken",
	["Suppress automated outbound whispers"] = "Unterdr\195\188ckt automatisch Nachrichten die rausgehen ",
	["Suppress Inbound"] = "Eingehende Unterdr\195\188cken",
	["Suppress incoming whispers during an bossfight"] = "Unterdr\195\188ckt automatisch Nachrichten die im Bosskampf eingehen",
	-- these need translation!
	["Suppress group members"] = "Unterdr\195\188cke Raid/Gruppenmitglieder",
	["Suppress group/raid whispers during combat"] = "Unterdr\195\188ckt Nachrichten von Raid/Gruppenmitgliedern im Kampf",
	-- /these need translation!
	["No whispers received"] = "Keine Nachtrichten empfangen",
	["Message Limit"] = "Nachrichten H\195\182chstanzahl",
	["Maximum number of messages to store per player."] = "H\195\182chstanzahl der gespeicherten Nachrichten f\195\188r Spieler",
	["PlayerDesc"] = "Nachrichten bekommen/gesendet von %s",
	["Reset before Combat"] = "Vor dem Kampf zur\195\188cksetzen",
	["Reset all previous incoming whispers when you start another bossfight."] = "Setzt alle Nachrichten zur\195\188ck wenn du einen neuen Boss bek\195\164mpfst",
	["Purge"] = "Nachrichten l\195\182schen",
	["PurgeDesc"] = "Setzt alle im Moment gespeicherten Nachrichten zur\195\188ck"
} end)

L:RegisterTranslations("frFR", function() return {
	["Bosswhisperer"] = "BossMessages",
	["dndMessage"] = "Je suis au combat avec %s (encore %d%% de vie). Tu seras inform\195\169 a la fin du combat.",
	["dndEndMessage"] = "Combat termin\195\169 apres %d minutes.",
	["Player Limit"] = "Joueurs max.",
	["Maximum number of players to store messages for."] = "Nombre maximale des joueurs pour l'historique des messages",
	["Suppress Outbound"] = "Cacher sortants",
	["Suppress automated outbound whispers"] = "Cache automatiquement les messages sortants",
	["Suppress Inbound"] = "Chacher entrants",
	["Suppress incoming whispers during an bossfight"] = "Cache automatiquement les messages entrants pendant un combat",
	-- these need translation!
	["Suppress group members"] = "Cacher messages du groupe/raid",
	["Suppress group/raid whispers during combat"] = "Cacher messages du groupe/raid en combat",
	-- /these need translation!
	["No whispers received"] = "Pas de messages re\195\135us",
	["Message Limit"] = "Nombre max. des messages",
	["Maximum number of messages to store per player."] = "Nombre max. des messages par joueur",
	["PlayerDesc"] = "Messages re\195\135us/envoy\195\169s de/a %s",
	["Reset before Combat"] = "Reset avant un combat",
	["Reset all previous incoming whispers when you start another bossfight."] = "Reset de tout les messages entrants au d\195\196but du prochain combat",
	["Purge"] = "Effacer messages",
	["PurgeDesc"] = "Efface tout les messages enregistr\195\169s "
} end)

L:RegisterTranslations("koKR", function() return {
	["dndMessage"] = "전투 중 입니다. (%s: %d%%) 전투가 끝나면 알려드리겠습니다.",
	["dndEndMessage"] = "전투 종료. (소요시간 %d분)",
	["Player Limit"] = "최대 답변수",
	["Maximum number of players to store messages for."] = "최대 몇명에게 답변을 할지 설정합니다",
	["Suppress Outbound"] = "보내는 귓속말 숨김",
	["Suppress automated outbound whispers"] = "당신이 보내는 귓속말을 숨깁니다",
	["Suppress Inbound"] = "받는 귓속말 숨김",
	["Suppress incoming whispers during an bossfight"] = "전투 중에 받는 귓속말을 숨깁니다",
	["Suppress group members"] = "공격대/파티원의 귓속말 숨김",
	["Suppress group/raid whispers during combat"] = "전투 중에 공격대/파티원의 귓속말을 숨깁니다",
	["No whispers received"] = "귓속말이 오지 않았습니다.",
	["Message Limit"] = "최대 메세지",
	["Maximum number of messages to store per player."] = "플레이어별로 저장되는 최대 메세지를 설정합니다",
	["PlayerDesc"] = "귓속말 보냄/받음 %s",
	["Reset before Combat"] = "전투 시작전 초기화",
	["Reset all previous incoming whispers when you start another bossfight."] = "전투가 시작될 때 받은 귓속말들을 초기화 합니다",
	["Purge"] = "귓속말 청소",
	["PurgeDesc"] = "저장된 모든 귓속말을 초기화 합니다"
} end)

local Tablet = AceLibrary("Tablet-2.0")

local BossWhisperer = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0", "FuBarPlugin-2.0", "AceHook-2.1")

local options = {
	type = "group",
	handler = BossWhisperer,
	pass = true,
	get = function(key)
		return BossWhisperer.db.profile[key]
	end,
	set = function(key, val)
		BossWhisperer.db.profile[key] = val
	end,
	args = {
		SuppressOutbound = {
			type = "toggle",
			name = L["Suppress Outbound"],
			desc = L["Suppress automated outbound whispers"],
		},
		SuppressInbound = {
			type = "toggle",
			name = L["Suppress Inbound"],
			desc = L["Suppress incoming whispers during an bossfight"],
		},
		SuppressGroup = {
			type = "toggle",
			name = L["Suppress group members"],
			desc = L["Suppress group/raid whispers during combat"],
		},
		resetBeforeCombat = {
			type = "toggle",
			name = L["Reset before Combat"],
			desc = L["Reset all previous incoming whispers when you start another bossfight."],
		},
		Playerlimit = {
			type = "range",
			name = L["Player Limit"],
			desc = L["Maximum number of players to store messages for."],
			max = 20,
			min = 5,
			step = 1,
		},
		Messagelimit = {
			type = "range",
			name = L["Message Limit"],
			desc = L["Maximum number of messages to store per player."],
			max = 20,
			min = 5,
			step = 1,
		},
		purge = {
			type = "execute",
			name = L["Purge"],
			desc = L["PurgeDesc"],
			func = "PurgeWhispers",
		},
	},
}

BossWhisperer.hasIcon = true

function BossWhisperer:OnInitialize()

	self:RegisterDB("BossWhispererDB", "BossWhispererDBPC", "profile")

	self:RegisterChatCommand("/bosswhisperer", "/bws", options, "BOSSWHISPERER")

	self:RegisterDefaults("profile", {
		PlayerLimit       = 10,
		MessageLimit      = 5,
		data              = {},
		SuppressOutbound  = true,
		SuppressInbound   = true,
		resetBeforeCombat = true,
		timeFormat        = "%H:%M:%S"
	})

	self.inCombat = nil

	self.combatStart = nil
	self.boss = nil
	self.bossHp = nil

	self.pname = UnitName("player")
	self.gname = GetGuildInfo("player")

	self.OnMenuRequest = options
	self.hasNoColor = false
	self.DEBUG = false

	self.whisperers = {}
	self.db.profile.data = {}
	self.banner = "<BWS>"
end

function BossWhisperer:OnEnable(first)
	self:RegisterEvent("PLAYER_REGEN_ENABLED", "CombatDisabled")
	self:RegisterEvent("PLAYER_REGEN_DISABLED", "CombatEnabled")

	self:RegisterEvent("CHAT_MSG_WHISPER", "IncomingWhisperControl")

	self.Original_ChatFrame_MessageEventHandler = _G.ChatFrame_MessageEventHandler
	_G.ChatFrame_MessageEventHandler = self.FilterChatMessage
end

function BossWhisperer:OnDisable()
	_G.ChatFrame_MessageEventHandler = self.Original_ChatFrame_MessageEventHandler
end

function BossWhisperer.FilterChatMessage(event)
	if event == "CHAT_MSG_WHISPER_INFORM" and BossWhisperer.db.profile.SuppressOutbound and arg1 and arg1 ~= "" and arg1:sub(1, string.len(BossWhisperer.banner)) == BossWhisperer.banner and arg6~="GM" then
		return
	elseif event == "CHAT_MSG_WHISPER" and BossWhisperer.db.profile.SuppressInbound and BossWhisperer.combatStart and arg6~="GM" then
		if not (BossWhisperer.db.profile.SuppressGroup) and GetGuildInfo(arg2) == BossWhisperer.gname then
			return
		end
	end
	return BossWhisperer.Original_ChatFrame_MessageEventHandler(event)
end

--blatantly stolen from FuWhisper which records whispers as well

local dataTablePool = setmetatable({ }, { __mode="k" })

local function new()
	local recycledTable = next(dataTablePool)
	if recycledTable then
		dataTablePool[recycledTable] = nil
		return recycledTable
	else
		return { }
	end
end

local function del(t, recursive)
	for k,v in pairs(t) do
		if recursive and type(v) == "table" then
			del(v, true)
		end
		t[k] = nil
	end
	dataTablePool[t] = true
end

local function copyTable(source)
	local result = new()

	for k,v in pairs(source) do
		if type(v) == "table" then
			result[k] = copyTable(v)
		else
			result[k] = v
		end
	end
	
	return result
end

function BossWhisperer:CreateMessageEntry()
	local data = new()
	data.time = time()
	data.message = arg1
	return data
end

function BossWhisperer:ProcessWhisper()
	-- Check that the whisper is from a new person.
	local profile = self.db.profile
	
	for i = 1, profile.PlayerLimit do
		if(not profile.data[i]) then
			break
		end
		if(arg2 == profile.data[i].name) then
			table.insert(profile.data[i].messageList, 1, BossWhisperer:CreateMessageEntry())

			for j = profile.MessageLimit+1, #profile.data[i].messageList do
				profile.data[i].messageList[j] = del(profile.data[i].messageList[j], true)
			end

			-- Move to top of list
			local data = table.remove(profile.data, i)
			table.insert(profile.data, 1, data)
			
			return
		end
	end

	-- Move the list down and add new whisperer to the top
	local newData = new()
	newData.name = arg2
	newData.messageList = new()
	newData.messageList[1] = self:CreateMessageEntry()
	table.insert(profile.data, 1, newData)

	for i = profile.PlayerLimit+1, #profile.data do
		profile.data[i] = del(profile.data[i], true)
	end

end

function BossWhisperer:OnTooltipUpdate()
	local cat
	local profile = self.db.profile
	
	for i=1,self.db.profile.PlayerLimit do
		if self.db.profile.data[i] then
			local data = profile.data[i]
			cat = Tablet:AddCategory(
				"text", data.name,
				"columns", 2
			)
			for i=#data.messageList,1,-1 do
				local messageEntry = data.messageList[i] 
				local messageList = BossWhisperer:CreateMessageList(messageEntry.message)
				
				for i=1,#messageList do
					cat:AddLine(
						"text", messageList[i],
						"textR", 0.0,
						"textG", 1.0,
						"textB", 0.0,
						i == 1 and "text2" or nil, i == 1 and date(profile.timeFormat, tonumber(messageEntry.time)) or nil
					)
				end
				del(messageList)
			end
		end
	end
end

function BossWhisperer:CreateMessageList(message)
	local wrapLength = 65

	local messageList = new()
	
	if #message <= wrapLength then
		messageList[1] = message
		return messageList
	end

	local startIndex = 1
	while startIndex <= #message do
		local endIndex = startIndex + wrapLength
		if endIndex > #message then
			messageList[#messageList+1] = message:sub(startIndex)
			break
		end
		while message:byte(endIndex) ~= 32 do
			endIndex = endIndex - 1
			if endIndex == startIndex then
				endIndex = startIndex + wrapLength
				break
			end
		end
		messageList[#messageList+1] = message:sub(startIndex, endIndex)
		startIndex = endIndex+1
	end

	return messageList
end


function BossWhisperer:IncomingWhisperControl(event, ...)
-- If not whispering self then let him know we are fighting a boss (but don't reply to BossWhisperer2 messages)
	if self.combatStart and type(arg2) == "string" then
		if arg2 ~= self.pname and not (arg1:sub(1, string.len(self.banner)) == self.banner) then
			self:ProcessWhisper()
			self.whisperers[arg2] = true
			local msg = self.banner .. L["dndMessage"]
			SendChatMessage(string.format(msg, self.bossName or "Unknown", self.bossHp or "100"), "WHISPER", nil, arg2)
		end
	end
end

function BossWhisperer:checkTarget(id)
	return UnitExists(id) and UnitAffectingCombat(id) and UnitClassification(id) == "worldboss"
end

function BossWhisperer:isPartied(name)
	if UnitInRaid("player") then
		for i = 1, 40 do
			if UnitName("raid"..i) == name then return true end
		end
	else
		for i = 1, 5 do
			if UnitName("party"..i) == name then return true end
		end
	end
	return false
end

function BossWhisperer:scanTargets()
	if BossWhisperer:checkTarget("target") then return "target" end
	if BossWhisperer:checkTarget("focus") then return "focus" end
	if UnitInRaid("player") then
		for i = 1, 40 do
			if BossWhisperer:checkTarget("raid"..i.."target") then return "raid"..i.."target" end
		end
	else
		for i = 1, 5 do
			if BossWhisperer:checkTarget("party"..i.."target") then return "party"..i.."target" end
		end
	end
end

function BossWhisperer:UpdateTarget(id)
	if self:checkTarget(id) then 
		self.combatStart = GetTime()
		self.bossName = UnitName(id)
		self.bossHp = UnitHealth(id)
		
		self:RegisterEvent("UNIT_HEALTH", "UpdateHealth")
		
		self:UnregisterEvent("UNIT_TARGET")
	end
end


function BossWhisperer:CombatEnabled()
	local target = BossWhisperer:scanTargets()
	if self.db.profile.resetBeforeCombat then
		self:PurgeWhispers()
	end

	if not target then
	-- if target is empty no boss has been found
	-- certain bosses dont start with a "worldboss" class boss being targeted by someone (Magtheridon comes to mind)
	-- so register the event UNIT_TARGET to keep checking if someone has the boss targeted during the fight
		self:RegisterEvent("UNIT_TARGET", "UpdateTarget")
	else
		self.combatStart = GetTime()
		self.bossName = UnitName(target)
		self.bossHp = UnitHealth(target)
		
		self:RegisterEvent("UNIT_HEALTH", "UpdateHealth")
	end
end

function BossWhisperer:CombatDisabled()
	if self.combatStart then
		local time = GetTime() - self.combatStart
		local msg = self.banner .. L["dndEndMessage"]:format(math.floor(time / 60))
		
		for k, v in pairs(self.whisperers) do
			-- Notify people that combat has ended
			SendChatMessage(msg, "WHISPER", nil, k)
			self.whisperers[k] = nil
		end
		self.combatStart = nil
		self.bossName = nil
		self.bossHp = nil
		self:UnregisterEvent("UNIT_HEALTH")
	end
end

function BossWhisperer:PurgeWhispers()
	del(self.db.profile.data, true)
	self.db.profile.data = new()
end

function BossWhisperer:UpdateHealth()
	if arg1 and UnitName(arg1) == self.bossName then
		self.bossHp = UnitHealth(arg1)
	end
end

